
Imports System
Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
Imports System.Windows.Forms

Module IconsMenuMain
    Dim colorTrans As ColorTranslator

    Public SideBarColor As Color = Color.LightGray
    Public MenuBackColor As Color = colorTrans.FromWin32(RGB(255, 251, 247))
    Public MenuSeperaterWidth As Integer = 1
    Public MenuSeperaterColor As Color = SideBarColor
    Public SelectedGradientLeft As Color = (colorTrans.FromWin32(RGB(181, 190, 214)))
    Public SelectedGradientRight As Color = (colorTrans.FromWin32(RGB(181, 190, 214)))

    Dim m_Font As New Font("Arial", 8)
    Sub MeasureItems(ByVal EvMeasureItem As System.Windows.Forms.MeasureItemEventArgs, ByVal Mi As MenuItem)
        Dim sf As StringFormat = New StringFormat()
        sf.HotkeyPrefix = HotkeyPrefix.Show
        sf.SetTabStops(60, New Single() {0})
        If GetRealText(Mi) <> "-" Then
            EvMeasureItem.ItemHeight = 23
        Else
            EvMeasureItem.ItemHeight = MenuSeperaterWidth
        End If
        EvMeasureItem.ItemWidth = CInt(EvMeasureItem.Graphics.MeasureString(GetRealText(Mi), m_Font, 10000, sf).Width) + 25
        sf.Dispose()
        sf = Nothing
    End Sub
    Sub DrawItems(ByVal EvDrawItems As System.Windows.Forms.DrawItemEventArgs, ByVal Mi As MenuItem, ByVal m_Icon As Icon)
        If GetRealText(Mi) <> "-" Then
            Dim br As Brush
            Dim fDisposeBrush As Boolean
            If Not m_Icon Is Nothing Then
                If Not Mi.Checked Then
                    EvDrawItems.Graphics.DrawIcon(m_Icon, EvDrawItems.Bounds.Left + 2, EvDrawItems.Bounds.Top + 2)
                Else
                    EvDrawItems.Graphics.DrawIcon(m_Icon, EvDrawItems.Bounds.Left + 2, EvDrawItems.Bounds.Top + 2)
                    Dim nPen As System.Drawing.Pen
                    If Not Mi.Enabled Then
                        NPEN = New Pen(Color.DarkGray)
                    Else
                        nPen = New Pen(Color.Gray)
                    End If
                    EvDrawItems.Graphics.DrawRectangle(nPen, 1, EvDrawItems.Bounds.Top, 20, 20)
                    EvDrawItems.Graphics.DrawRectangle(nPen, 3, EvDrawItems.Bounds.Top + 2, 16, 16)
                End If
            Else
                If Mi.Checked Then
                    Dim nPen As System.Drawing.Pen
                    If Not Mi.Enabled Then
                        NPEN = New Pen(Color.DarkGray)
                    Else
                        nPen = New Pen(Color.Gray)
                    End If
                    EvDrawItems.Graphics.DrawRectangle(npen, 1, EvDrawItems.Bounds.Top, 20, 20)
                    Dim Pnts() As Point
                    ReDim Pnts(2)
                    Pnts(0) = New Point(15, EvDrawItems.Bounds.Top + 6)
                    Pnts(1) = New Point(8, EvDrawItems.Bounds.Top + 13)
                    Pnts(2) = New Point(5, EvDrawItems.Bounds.Top + 10)
                    If Mi.Enabled Then
                        EvDrawItems.Graphics.DrawLines(New Pen(Color.Black), Pnts)
                    Else
                        EvDrawItems.Graphics.DrawLines(New Pen(Color.Gray), Pnts)
                    End If
                End If
            End If
            Dim rcBk As Rectangle = EvDrawItems.Bounds
            rcBk.X += 1

            If CBool(EvDrawItems.State And DrawItemState.Selected) Then
                br = New LinearGradientBrush(rcBk, SelectedGradientLeft, SelectedGradientRight, 0)
                EvDrawItems.Graphics.FillRectangle(br, rcBk.X + 1, rcBk.Y + 1, rcBk.Width - 1, rcBk.Height - 3)
                EvDrawItems.Graphics.DrawRectangle(Pens.Black, rcBk.X - 1, rcBk.Y + 1, rcBk.Width - 1, rcBk.Height - 3)

                If m_Icon Is Nothing Then
                Else
                    EvDrawItems.Graphics.DrawIcon(m_Icon, EvDrawItems.Bounds.Left + 2, EvDrawItems.Bounds.Top + 3)
                End If
                fDisposeBrush = True
            Else
                br = New SolidBrush(MenuBackColor)
                EvDrawItems.Graphics.FillRectangle(br, rcBk)
                EvDrawItems.Graphics.FillRectangle(New SolidBrush(SideBarColor), 0, EvDrawItems.Bounds.Top, 20, EvDrawItems.Bounds.Height)
                If m_Icon Is Nothing Then
                Else
                    EvDrawItems.Graphics.DrawIcon(m_Icon, EvDrawItems.Bounds.Left + 3, EvDrawItems.Bounds.Top + 4)
                End If
            End If

            If fDisposeBrush Then br.Dispose()
            br = Nothing
            Dim sf As StringFormat = New StringFormat()
            sf.HotkeyPrefix = HotkeyPrefix.Show
            sf.SetTabStops(60, New Single() {0})
            If Mi.Enabled Then
                br = New SolidBrush(Color.Black)
            Else
                br = New SolidBrush(Color.Gray)
            End If
            EvDrawItems.Graphics.DrawString(GetRealText(Mi), m_Font, br, EvDrawItems.Bounds.Left + 25, EvDrawItems.Bounds.Top + 4, sf)

            br.Dispose()
            br = Nothing
            sf.Dispose()
            sf = Nothing
        Else
            EvDrawItems.Graphics.FillRectangle(New SolidBrush(MenuBackColor), 0, EvDrawItems.Bounds.Top, EvDrawItems.Bounds.Width, EvDrawItems.Bounds.Height)
            EvDrawItems.Graphics.FillRectangle(New SolidBrush(MenuSeperaterColor), 30, EvDrawItems.Bounds.Top, EvDrawItems.Bounds.Width, EvDrawItems.Bounds.Height)
            EvDrawItems.Graphics.FillRectangle(New SolidBrush(MenuSeperaterColor), 0, EvDrawItems.Bounds.Top, 20, EvDrawItems.Bounds.Height)
        End If
    End Sub

    Function GetRealText(ByVal Mi As MenuItem) As String
        Dim s As String = Mi.Text
        If Mi.ShowShortcut And Mi.Shortcut <> Shortcut.None Then
            Dim k As Keys = CType(Mi.Shortcut, Keys)
            s = s & Convert.ToChar(9) & TypeDescriptor.GetConverter(GetType(Keys)).ConvertToString(k)
        End If
        Return s
    End Function

    Public Sub measureMenuBarItem(ByVal EvMeasureItem As System.Windows.Forms.MeasureItemEventArgs, ByVal Mi As MenuItem)
        Dim sf As StringFormat = New StringFormat()
        sf.HotkeyPrefix = HotkeyPrefix.Show
        sf.SetTabStops(60, New Single() {0})
        EvMeasureItem.ItemHeight = 25
        EvMeasureItem.ItemWidth = CInt(EvMeasureItem.Graphics.MeasureString(GetRealText(Mi), m_Font, 10000, sf).Width) - 2
        sf.Dispose()
        sf = Nothing
    End Sub

    Public Sub drawMenuBarItem(ByVal e As System.Windows.Forms.DrawItemEventArgs, ByVal Mi As MenuItem)
        If CBool(e.State And DrawItemState.HotLight) Then
            e.Graphics.FillRectangle(New SolidBrush(SelectedGradientLeft), e.Bounds.X + 1, e.Bounds.Y, e.Bounds.Width - 1, e.Bounds.Height - 1)
            e.Graphics.DrawRectangle(Pens.Black, e.Bounds.X + 1, e.Bounds.Y, e.Bounds.Width - 1, e.Bounds.Height - 1)
            e.Graphics.DrawString(Mi.Text, m_Font, Brushes.Black, e.Bounds.Left + 6, e.Bounds.Top + 3)
        ElseIf CBool(e.State And DrawItemState.Selected) Then
            e.Graphics.FillRectangle(New SolidBrush(SideBarColor), e.Bounds.X + 1, e.Bounds.Y + 1, e.Bounds.Width - 1, e.Bounds.Height - 1)
            e.Graphics.DrawLine(Pens.Black, e.Bounds.Left + 1, e.Bounds.Top, e.Bounds.Left + 1, e.Bounds.Bottom - 1)
            e.Graphics.DrawLine(Pens.Black, e.Bounds.Left + 1 + (e.Bounds.Width - 1), e.Bounds.Top + 1, e.Bounds.Left + 1 + (e.Bounds.Width - 1), e.Bounds.Bottom - 1)
            e.Graphics.DrawLine(Pens.Black, e.Bounds.Left + 1, e.Bounds.Top, e.Bounds.Left + 1 + (e.Bounds.Width - 1), e.Bounds.Top)
            e.Graphics.DrawString(Mi.Text, m_Font, Brushes.Black, e.Bounds.Left + 6, e.Bounds.Top + 3)
        Else
            e.Graphics.FillRectangle(SystemBrushes.Control, e.Bounds.X, e.Bounds.Y, e.Bounds.Width + 1, e.Bounds.Height)
            e.Graphics.DrawString(Mi.Text, m_Font, Brushes.Black, e.Bounds.Left + 6, e.Bounds.Top + 3)
        End If
    End Sub
End Module
